/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.source.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.etools.c.source.CBlock;
import com.ibm.etools.c.source.CStatement;
import com.ibm.etools.c.source.SourcePackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>CStatement</b></em>'. <!-- end-user-doc -->
 * <p>
 * </p>
 * 
 * @generated
 */
public class CStatementImpl extends CBlockImpl implements CStatement {
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected CStatementImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return SourcePackage.eINSTANCE.getCStatement();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case SourcePackage.CSTATEMENT__NESTS:
                if (eContainer != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return eBasicSetContainer(otherEnd, SourcePackage.CSTATEMENT__NESTS, msgs);
            case SourcePackage.CSTATEMENT__NESTED:
                return ((InternalEList) getNested()).basicAdd(otherEnd, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case SourcePackage.CSTATEMENT__NESTS:
                return eBasicSetContainer(null, SourcePackage.CSTATEMENT__NESTS, msgs);
            case SourcePackage.CSTATEMENT__NESTED:
                return ((InternalEList) getNested()).basicRemove(otherEnd, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
        if (eContainerFeatureID >= 0) {
            switch (eContainerFeatureID) {
            case SourcePackage.CSTATEMENT__NESTS:
                return ((InternalEObject) eContainer).eInverseRemove(this, SourcePackage.CBLOCK__NESTED, CBlock.class, msgs);
            default:
                return eDynamicBasicRemoveFromContainer(msgs);
            }
        }
        return ((InternalEObject) eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case SourcePackage.CSTATEMENT__SOURCE:
            return getSource();
        case SourcePackage.CSTATEMENT__NESTS:
            return getNests();
        case SourcePackage.CSTATEMENT__NESTED:
            return getNested();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case SourcePackage.CSTATEMENT__SOURCE:
            setSource((String) newValue);
            return;
        case SourcePackage.CSTATEMENT__NESTS:
            setNests((CBlock) newValue);
            return;
        case SourcePackage.CSTATEMENT__NESTED:
            getNested().clear();
            getNested().addAll((Collection) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case SourcePackage.CSTATEMENT__SOURCE:
            setSource(SOURCE_EDEFAULT);
            return;
        case SourcePackage.CSTATEMENT__NESTS:
            setNests((CBlock) null);
            return;
        case SourcePackage.CSTATEMENT__NESTED:
            getNested().clear();
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case SourcePackage.CSTATEMENT__SOURCE:
            return SOURCE_EDEFAULT == null ? source != null : !SOURCE_EDEFAULT.equals(source);
        case SourcePackage.CSTATEMENT__NESTS:
            return getNests() != null;
        case SourcePackage.CSTATEMENT__NESTED:
            return nested != null && !nested.isEmpty();
        }
        return eDynamicIsSet(eFeature);
    }

} //CStatementImpl
