/**
 * <copyright>
 * </copyright>
 *
 * $Id: COBOL88ElementValue.java,v 1.2 2004/10/21 21:57:45 akkina Exp $
 */
package com.ibm.etools.cobol;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>88 Element Value</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Example of this class in use:
 * 1 TESTX PIC X.
 *    88 TRUEX VALUE 'T' 't'.   *(TRUEX has 2 values)
 *    88 FALSEX VALUE 'F' 'f'.     *(FALSEX has 2 values)
 *    88 UA VALUE 'A' THRU 'I' 'J' THRU 'R' 'S' THRU 'Z' '&' '-'.
 *          *UA has 5 values; the first 3 are ranges
 * 
 * Rationale for this class:
 * -- This class exists because each COBOL88Element can contain more than 1 value.  For example, TRUEX contains 2 values, 'T' and 't'.  Thus this class can be instatiated more than once (but at least once) per COBOL88Element (and thus the 1...* cardinality)
 * --  For range values such as 'A' THRU 'I' in UA, lowerLimit = 'A' , upperLimit = 'I', and range = true.  Also note that when using the THRU keyword, lowerLimit must be less than upperLimit.
 * -- For non-range values such as 'T' and 't' we have decided that we would use lowerLimit field to represent the value.
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.ibm.etools.cobol.COBOL88ElementValue#getLowerLimit <em>Lower Limit</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOL88ElementValue#getUpperLimit <em>Upper Limit</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOL88ElementValue#getRange <em>Range</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOL88ElementValue()
 * @model 
 * @generated
 */
public interface COBOL88ElementValue extends EObject {
	/**
	 * Returns the value of the '<em><b>Lower Limit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * lowerLimit refers to the lower bound of the THROUGH range
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Lower Limit</em>' attribute.
	 * @see #setLowerLimit(String)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOL88ElementValue_LowerLimit()
	 * @model 
	 * @generated
	 */
	String getLowerLimit();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOL88ElementValue#getLowerLimit <em>Lower Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Lower Limit</em>' attribute.
	 * @see #getLowerLimit()
	 * @generated
	 */
	void setLowerLimit(String value);

	/**
	 * Returns the value of the '<em><b>Upper Limit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * upperLimit refers to the upper bound of the THROUGH range
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Upper Limit</em>' attribute.
	 * @see #setUpperLimit(String)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOL88ElementValue_UpperLimit()
	 * @model 
	 * @generated
	 */
	String getUpperLimit();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOL88ElementValue#getUpperLimit <em>Upper Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Upper Limit</em>' attribute.
	 * @see #getUpperLimit()
	 * @generated
	 */
	void setUpperLimit(String value);

	/**
	 * Returns the value of the '<em><b>Range</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * If range is set to true, literal-1 must be less than literal-2, unless the associated data item is a windowed date field. 
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Range</em>' attribute.
	 * @see #setRange(Boolean)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOL88ElementValue_Range()
	 * @model 
	 * @generated
	 */
	Boolean getRange();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOL88ElementValue#getRange <em>Range</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Range</em>' attribute.
	 * @see #getRange()
	 * @generated
	 */
	void setRange(Boolean value);

} // COBOL88ElementValue
