/**
 * <copyright>
 * </copyright>
 *
 * $Id: COBOLElement.java,v 1.2 2004/10/21 21:57:45 akkina Exp $
 */
package com.ibm.etools.cobol;

import com.ibm.etools.tdlang.TDLangElement;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Element</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A COBOLElement represents every data definition in the COBOL program.  
 * For example:
 * 01 EMPLOYEE
 *     03 SERIAL-NUMBER PIC 9(5).
 *     03 DEPARTMENT PIC (5).
 * 
 * EMPLOYEE, SERIAL-NUMBER, and DEPARTMENT are all COBOLElements.
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.ibm.etools.cobol.COBOLElement#getLevel <em>Level</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLElement#getRedefined <em>Redefined</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLElement#getIsFiller <em>Is Filler</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLElement#getIsExternal <em>Is External</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLElement#getIsGlobal <em>Is Global</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLElement#getContains <em>Contains</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLElement#getSharedType <em>Shared Type</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLElement#getArray <em>Array</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLElement#getGroup <em>Group</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLElement#getSource <em>Source</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLElement#getInitial <em>Initial</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLElement()
 * @model 
 * @generated
 */
public interface COBOLElement extends TDLangElement {
	/**
	 * Returns the value of the '<em><b>Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Level refers to the data number this element was declared in.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Level</em>' attribute.
	 * @see #setLevel(String)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLElement_Level()
	 * @model 
	 * @generated
	 */
	String getLevel();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLElement#getLevel <em>Level</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Level</em>' attribute.
	 * @see #getLevel()
	 * @generated
	 */
	void setLevel(String value);

	/**
	 * Returns the value of the '<em><b>Redefined</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Redefined</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Redefined</em>' attribute.
	 * @see #setRedefined(Boolean)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLElement_Redefined()
	 * @model default="false"
	 * @generated
	 */
	Boolean getRedefined();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLElement#getRedefined <em>Redefined</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Redefined</em>' attribute.
	 * @see #getRedefined()
	 * @generated
	 */
	void setRedefined(Boolean value);

	/**
	 * Returns the value of the '<em><b>Is Filler</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Is Filler</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Is Filler</em>' attribute.
	 * @see #setIsFiller(Boolean)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLElement_IsFiller()
	 * @model default="false"
	 * @generated
	 */
	Boolean getIsFiller();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLElement#getIsFiller <em>Is Filler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Filler</em>' attribute.
	 * @see #getIsFiller()
	 * @generated
	 */
	void setIsFiller(Boolean value);

	/**
	 * Returns the value of the '<em><b>Is External</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Is External</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Is External</em>' attribute.
	 * @see #setIsExternal(Boolean)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLElement_IsExternal()
	 * @model default="false"
	 * @generated
	 */
	Boolean getIsExternal();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLElement#getIsExternal <em>Is External</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is External</em>' attribute.
	 * @see #getIsExternal()
	 * @generated
	 */
	void setIsExternal(Boolean value);

	/**
	 * Returns the value of the '<em><b>Is Global</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Is Global</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Is Global</em>' attribute.
	 * @see #setIsGlobal(Boolean)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLElement_IsGlobal()
	 * @model default="false"
	 * @generated
	 */
	Boolean getIsGlobal();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLElement#getIsGlobal <em>Is Global</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Global</em>' attribute.
	 * @see #getIsGlobal()
	 * @generated
	 */
	void setIsGlobal(Boolean value);

	/**
	 * Returns the value of the '<em><b>Contains</b></em>' containment reference list.
	 * The list contents are of type {@link com.ibm.etools.cobol.COBOL88Element}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Rationale for this multiplicity value:
	 * -- Each COBOLElement can contain zero or any number of  COBOL88Elements, thus the 0..* multiplicity.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Contains</em>' containment reference list.
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLElement_Contains()
	 * @model type="com.ibm.etools.cobol.COBOL88Element" containment="true"
	 * @generated
	 */
	EList getContains();

	/**
	 * Returns the value of the '<em><b>Shared Type</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link com.ibm.etools.cobol.COBOLClassifier#getTypedElement <em>Typed Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Shared Type</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Shared Type</em>' reference.
	 * @see #setSharedType(COBOLClassifier)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLElement_SharedType()
	 * @see com.ibm.etools.cobol.COBOLClassifier#getTypedElement
	 * @model opposite="typedElement" required="true"
	 * @generated
	 */
	COBOLClassifier getSharedType();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLElement#getSharedType <em>Shared Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Shared Type</em>' reference.
	 * @see #getSharedType()
	 * @generated
	 */
	void setSharedType(COBOLClassifier value);

	/**
	 * Returns the value of the '<em><b>Array</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Array</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Array</em>' containment reference.
	 * @see #setArray(COBOLFixedLengthArray)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLElement_Array()
	 * @model containment="true"
	 * @generated
	 */
	COBOLFixedLengthArray getArray();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLElement#getArray <em>Array</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Array</em>' containment reference.
	 * @see #getArray()
	 * @generated
	 */
	void setArray(COBOLFixedLengthArray value);

	/**
	 * Returns the value of the '<em><b>Group</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link com.ibm.etools.cobol.COBOLComposedType#getElement <em>Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Group</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Group</em>' container reference.
	 * @see #setGroup(COBOLComposedType)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLElement_Group()
	 * @see com.ibm.etools.cobol.COBOLComposedType#getElement
	 * @model opposite="element"
	 * @generated
	 */
	COBOLComposedType getGroup();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLElement#getGroup <em>Group</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Group</em>' container reference.
	 * @see #getGroup()
	 * @generated
	 */
	void setGroup(COBOLComposedType value);

	/**
	 * Returns the value of the '<em><b>Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Source</em>' reference.
	 * @see #setSource(COBOLSourceText)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLElement_Source()
	 * @model required="true"
	 * @generated
	 */
	COBOLSourceText getSource();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLElement#getSource <em>Source</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Source</em>' reference.
	 * @see #getSource()
	 * @generated
	 */
	void setSource(COBOLSourceText value);

	/**
	 * Returns the value of the '<em><b>Initial</b></em>' reference list.
	 * The list contents are of type {@link com.ibm.etools.cobol.COBOLElementInitialValue}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Initial</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Initial</em>' reference list.
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLElement_Initial()
	 * @model type="com.ibm.etools.cobol.COBOLElementInitialValue"
	 * @generated
	 */
	EList getInitial();

} // COBOLElement
