/**
 * <copyright>
 * </copyright>
 *
 * $Id: COBOLNumericEditedType.java,v 1.2 2004/10/21 21:57:45 akkina Exp $
 */
package com.ibm.etools.cobol;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Numeric Edited Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The PICTURE character-string can contain the following symbols: 
 *      B  P  V  Z  9  0  /  ,  .  +  -  CR  DB  *  cs 
 * 
 * Other clauses: USAGE DISPLAY must be specified or implied. 
 * Any associated VALUE clause must specify a nonnumeric literal or a figurative constant. The literal is treated exactly as specified; no editing is done. 
 * 
 * Edited Types are different from non-edited types in that the decimal character is stored in memory for edited types and not stored in non-edited types.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.ibm.etools.cobol.COBOLNumericEditedType#getBlankWhenZero <em>Blank When Zero</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLNumericEditedType#getCurrencySymbol <em>Currency Symbol</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLNumericEditedType#getCurrencySign <em>Currency Sign</em>}</li>
 *   <li>{@link com.ibm.etools.cobol.COBOLNumericEditedType#getDecimal <em>Decimal</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLNumericEditedType()
 * @model 
 * @generated
 */
public interface COBOLNumericEditedType extends COBOLSimpleType {
	/**
	 * Returns the value of the '<em><b>Blank When Zero</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This boolean corresponds to the BLANK WHEN ZERO clause.
	 * 
	 * True if BLANK WHEN ZERO.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Blank When Zero</em>' attribute.
	 * @see #setBlankWhenZero(Boolean)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLNumericEditedType_BlankWhenZero()
	 * @model default="false"
	 * @generated
	 */
	Boolean getBlankWhenZero();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLNumericEditedType#getBlankWhenZero <em>Blank When Zero</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Blank When Zero</em>' attribute.
	 * @see #getBlankWhenZero()
	 * @generated
	 */
	void setBlankWhenZero(Boolean value);

	/**
	 * Returns the value of the '<em><b>Currency Symbol</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This string represents different currency signs used in the world, for example, $, , DM, etc...
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Currency Symbol</em>' attribute.
	 * @see #setCurrencySymbol(String)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLNumericEditedType_CurrencySymbol()
	 * @model 
	 * @generated
	 */
	String getCurrencySymbol();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLNumericEditedType#getCurrencySymbol <em>Currency Symbol</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Currency Symbol</em>' attribute.
	 * @see #getCurrencySymbol()
	 * @generated
	 */
	void setCurrencySymbol(String value);

	/**
	 * Returns the value of the '<em><b>Currency Sign</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Currency Sign</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Currency Sign</em>' attribute.
	 * @see #setCurrencySign(String)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLNumericEditedType_CurrencySign()
	 * @model 
	 * @generated
	 */
	String getCurrencySign();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLNumericEditedType#getCurrencySign <em>Currency Sign</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Currency Sign</em>' attribute.
	 * @see #getCurrencySign()
	 * @generated
	 */
	void setCurrencySign(String value);

	/**
	 * Returns the value of the '<em><b>Decimal</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The Decimal boolean exchanges the functions of the peroid and comma in picture strings and numeric values.
	 * 
	 * If TRUE, decimals are used (e.g., 1,234.56)
	 * 
	 * If FALSE, commas are used (e.g., 1.234,56)
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Decimal</em>' attribute.
	 * @see #setDecimal(Boolean)
	 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLNumericEditedType_Decimal()
	 * @model 
	 * @generated
	 */
	Boolean getDecimal();

	/**
	 * Sets the value of the '{@link com.ibm.etools.cobol.COBOLNumericEditedType#getDecimal <em>Decimal</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Decimal</em>' attribute.
	 * @see #getDecimal()
	 * @generated
	 */
	void setDecimal(Boolean value);

} // COBOLNumericEditedType
